; ANN-GONG 
; by Stefano Tognon
; (C) 2005 Ice Team
; version 1.00

; Well, this game is also dedicated to my "Ann-Gong friend"
; This is my 10 game for C64 

       processor 6502
       
RASTER0   =  82      
X_CH_SIZE =  29    ; max size of chars in x


SCREEN     = $E536    ; clean the screen with color
SET_COOR   = $E50C    ; set x/y coord
STRING     = $AB1E    ; put a string

ROW_L8 = 1024+40*3
ROW_L7 = 1024+40*4
ROW_L5 = 1024+40*6
ROW_L4 = 1024+40*7
ROW_L3 = 1024+40*8
ROW_L2 = 1024+40*9
ROW_L1 = 1024+40*10
 
joystick   = $03      ; joystick values
GO         = $89      ; 1=go
temp1      = $92
temp2      = $93
       
 org 2049
 dc.b $0b,$08,$e8,$03,$9e,"2061",0,0,0
 org 2061

; install custom chars
                                  ; transfer characters codes to 14336
        sei

        lda  #$33
        sta  $01

        ldy #0
        ldx #8
lp1
        lda $d000,y
        sta $3800,y
        dey
        bne lp1
next
        inc lp1+2
        inc lp1+5
        dex
        beq exit
        cpx #$06 ; do not overwrite the predefined chars $3a00-3aff
        beq next
        bne lp1
exit
        lda  #$37
        sta  $01
        cli

  
; install interrupt routine
      sei
      lda  #<irqR0
      sta  $0314
      lda  #>irqR0
      sta  $0315
                                 ; disable cia interrupt
      ldx  #$00
      stx  $DC0E                 ; Control register A of CIA #1
      inx
      stx  $D01A                 ; IRQ mask register
      cli
                                 ; use VIC interrupt
      stx  $D019                 ; Interrupt indicator register
      lda  #RASTER0
      sta  $D012                  ; Reading/Writing IRQ balance value
      lda  #$1B
      sta  $D011                  ; VIC control register MCM char mode  
      lda  #$18
      sta  $D016      
      
                                  ; switch to new chars
      lda  #31
      sta  $D018
                                    
      ldx  #11
      stx  53281
      ;stx  53280
      
      inx
      stx  $D022                  ; mcm common color 1                  
            
      lda  #15
      sta  $D023 

                                  ; create the fixed screen
      lda  #15
      jsr  SCREEN                 ; clearing the screen with color
 
      lda  #<ROW_L1
      sta  temp1
      lda  #>ROW_L1
      sta  temp2
      lda  #CH_L1
      jsr  putRowChar
      inc  temp1
      lda  #CH_L1+1
      jsr  putRowChar1 

      lda  #<ROW_L2
      sta  temp1
      lda  #>ROW_L2
      sta  temp2
      lda  #CH_L2
      jsr  putRowChar
      inc  temp1
      lda  #(CH_L2+1)
      jsr  putRowChar1

      lda  #<ROW_L3
      sta  temp1
      lda  #>ROW_L3
      sta  temp2
      lda  #CH_L3
      jsr  putRowChar
      inc  temp1
      lda  #(CH_L3+1)
      jsr  putRowChar1

      lda  #<ROW_L4
      sta  temp1
      lda  #>ROW_L4
      sta  temp2                      
      lda  #CH_L4
      jsr  putRowChar
      inc  temp1
      lda  #(CH_L4+1)
      jsr  putRowChar1       
      
      lda  #<ROW_L5
      sta  temp1
      lda  #>ROW_L5
      sta  temp2                      
      lda  #CH_L5
      jsr  putRowChar
      inc  temp1
      lda  #(CH_L5+1)
      jsr  putRowChar1       
      
      lda  #<ROW_L7
      sta  temp1
      lda  #>ROW_L7
      sta  temp2   
      lda  #CH_LL
      ldy  #X_CH_SIZE+1
      
loopCp1:      
      sta    (temp1),y
      dey       
      bpl  loopCp1     
      
      
      ldx  #CH_MM
      stx  ROW_L7+1
      inx
      stx  ROW_L7+2
      
      ldx  #CH_L3
      stx  ROW_L7+3
      stx  ROW_L7+5
      stx  ROW_L7+7
      inx 
      stx  ROW_L7+4
      stx  ROW_L7+6
      ldx  #CH_L2
      stx  ROW_L7+8
      ldx  #(CH_MM+2)
      stx  ROW_L7+9
      inx  
      stx  ROW_L7+10
      
      
      ldx  #CH_MM
      stx  ROW_L7+15
      inx
      stx  ROW_L7+16
      inx
      stx  ROW_L7+17
      inx
      stx  ROW_L7+18
      
      
      ldx  #CH_MM
      stx  ROW_L7+21
      inx
      stx  ROW_L7+22
      inx
      stx  ROW_L7+23
      inx
      stx  ROW_L7+24      
                    
      
      lda  #<(1024+40*3)
      sta  temp1
      lda  #>(1024+40*3)
      sta  temp2   
      lda  #CH_V2
      ldy  #X_CH_SIZE+1           
loopCp1_:      
      sta    (temp1),y
      dey       
      bpl  loopCp1_   
      
            
      ldx  #CH_MM
      stx  ROW_L8+3
      inx
      stx  ROW_L8+4
      stx  ROW_L8+6     
      inx  
      stx  ROW_L8+5
      stx  ROW_L8+7
      inx       
      stx  ROW_L8+8       
      
      lda  #<(1024+40*2)
      sta  temp1
      lda  #>(1024+40*2)
      sta  temp2   
      lda  #CH_V2
      ldy  #X_CH_SIZE+1
      
loopCp1__:      
      sta    (temp1),y
      dey       
      bpl  loopCp1__
      
      lda  #<(1024+40*1)
      sta  temp1
      lda  #>(1024+40*1)
      sta  temp2   
      lda  #CH_V2
      ldy  #X_CH_SIZE+1
      
loopCp1___:      
      sta    (temp1),y
      dey       
      bpl  loopCp1___
      
      lda  #<(1024+40*0)
      sta  temp1
      lda  #>(1024+40*0)
      sta  temp2   
      lda  #CH_V2
      ldy  #X_CH_SIZE+1
      
loopCp1____:      
      sta    (temp1),y
      dey       
      bpl  loopCp1____        
      
      
      
      lda  #<(1024+40*11)
      sta  temp1
      lda  #>(1024+40*11)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp2:      
      sta    (temp1),y
      dey       
      bpl  loopCp2
      
      lda  #<(1024+40*12)
      sta  temp1
      lda  #>(1024+40*12)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp2_:      
      sta    (temp1),y
      dey       
      bpl  loopCp2_
      
      lda  #<(1024+40*13)
      sta  temp1
      lda  #>(1024+40*13)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp2__:      
      sta    (temp1),y
      dey       
      bpl  loopCp2__  
      
      lda  #<(1024+40*14)
      sta  temp1
      lda  #>(1024+40*14)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp3:      
      sta    (temp1),y
      dey       
      bpl  loopCp3
      
      lda  #<(1024+40*15)
      sta  temp1
      lda  #>(1024+40*15)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp3_:      
      sta    (temp1),y
      dey       
      bpl  loopCp3_
      
      lda  #<(1024+40*16)
      sta  temp1
      lda  #>(1024+40*16)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp3__:      
      sta    (temp1),y
      dey       
      bpl  loopCp3__       
      
      lda  #<(1024+40*17)
      sta  temp1
      lda  #>(1024+40*17)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp4:      
      sta    (temp1),y
      dey       
      bpl  loopCp4          
      
      lda  #<(1024+40*18)
      sta  temp1
      lda  #>(1024+40*18)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp5:      
      sta    (temp1),y
      dey       
      bpl  loopCp5    
      
      lda  #<(1024+40*19)
      sta  temp1
      lda  #>(1024+40*19)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp6:      
      sta    (temp1),y
      dey       
      bpl  loopCp6     
      
      lda  #<(1024+40*20)
      sta  temp1
      lda  #>(1024+40*20)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp6_:      
      sta    (temp1),y
      dey       
      bpl  loopCp6_
      
      lda  #<(1024+40*21)
      sta  temp1
      lda  #>(1024+40*21)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp7:      
      sta    (temp1),y
      dey       
      bpl  loopCp7       
      
      lda  #<(1024+40*22)
      sta  temp1
      lda  #>(1024+40*22)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp7_:      
      sta    (temp1),y
      dey       
      bpl  loopCp7_
      
      lda  #<(1024+40*23)
      sta  temp1
      lda  #>(1024+40*23)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp7__:      
      sta    (temp1),y
      dey       
      bpl  loopCp7__
      
      lda  #<(1024+40*24)
      sta  temp1
      lda  #>(1024+40*24)
      sta  temp2   
      lda  #CH_V1
      ldy  #X_CH_SIZE+1
      
loopCp7___:      
      sta    (temp1),y
      dey       
      bpl  loopCp7___                           
      
      
      
      ldx  #0
      ldy  #32
      jsr  SET_COOR
      lda  #<S1
      ldy  #>S1
      jsr  STRING                 ; put the name of the game
      

      ;rts


      ;lda  #CH_A
      ;sta  1024+40*5+35-1            
      ;lda  #CH_N
      ;sta  1024+40*5+36-1
      ;sta  1024+40*5+37-1
      
      ;lda  #CH_G
      ;sta  1024+40*7+35-1      
      ;sta  1024+40*7+38-1    
      ;lda  #CH_O               
      ;sta  1024+40*7+36-1
      ;lda  #CH_N               
      ;sta  1024+40*7+37-1      
           
         

      ldx  #22
      ldy  #35
      jsr  SET_COOR
      lda  #<S3
      ldy  #>S3
      jsr  STRING                 

      ldx  #23
      ldy  #32
      jsr  SET_COOR
      lda  #<S4
      ldy  #>S4
      jsr  STRING                 

      ldx  #24
      ldy  #32
      jsr  SET_COOR
      lda  #<S5
      ldy  #>S5
      jsr  STRING                 

      ldx  #19
      ldy  #33
      jsr  SET_COOR
      lda  #<S7
      ldy  #>S7
      jsr  STRING                 

      ldx  #17
      ldy  #33
      jsr  SET_COOR
      lda  #<S6
      ldy  #>S6
      jsr  STRING                 

      ldx  #13
      ldy  #33
      jsr  SET_COOR
      lda  #<S8
      ldy  #>S8
      jsr  STRING                 

      ldx  #15
      ldy  #35
      jsr  SET_COOR
      lda  #<S9
      ldy  #>S9
      jsr  STRING                 

aaa: jmp aaa      
      rts            
      
S1: .byte 5,"ANN GONG",0
;S2: .byte 5,"GONG",0

S8: .byte 5,"LEVEL",0
S9: .byte 5," ",0

S6: .byte 5,"ENERGY",0
S7: .byte 5,"      ",0

S3:  .byte 5,"BY",0
S4:  .byte 5,"ICE TEAM",0
S5:  .byte 5,"(C)2005",0

     

      
      
;==================================
; Put a row of 1 chars every 2 chars
; A= char to put (min)
; temp1/2: address of where to put
;==================================      
putRowChar:
      ldy  #X_CH_SIZE+1
loopCp:      
      sta  (temp1),y
      dey
      dey
      bpl  loopCp
      rts

;==================================
; Put a row of 1 chars every 2 chars
; A= char to put (min)
; temp1/2: address of where to put
;==================================      
putRowChar1:
      ldy  #X_CH_SIZE
      dec temp1
loopk:      
      sta  (temp1),y
      dey
      dey
      bpl  loopk
      rts
      
;==================================
; Get Joystick movement
;==================================
getJoystick:
      lda  #$FF
      sta  $DC00
      lda  $DC00
      eor  #$FF
      sta  joystick
      rts

;==================================
; Wait for IRQ before going on
;==================================
waitIRQ:
      lda  GO
      beq  waitIRQ
      dec  GO
      rts              
      
;==================================
; play music, set IRQ1, set graphics
; for scroll
;==================================
irqR0:
      ldx  #1
      stx  $d019                 ; acknowledge the raster interrupt
      
      lda  #1
      sta  GO     
      ;jsr  playMusic

      jmp  $ea81
      
             
  .org $2000      
      
  .byte 5, 106, 0, 1, 170, 0, 1, 170, 0
  .byte 1, 85, 0, 6, 166, 0, 6, 90, 128
  .byte 22, 170, 128, 26, 154, 160, 26, 150, 160
  .byte 26, 133, 104, 90, 129, 168, 106, 1, 168
  .byte 106, 1, 168, 106, 1, 168, 90, 1, 100
  .byte 25, 0, 80, 20, 0, 96, 120, 1, 112
  .byte 124, 1, 240, 127, 1, 252, 21, 0, 84, 0

  .byte 5, 186, 0, 1, 170, 0, 1, 170, 0
  .byte 1, 85, 0, 1, 166, 0, 1, 154, 0
  .byte 1, 166, 0, 1, 170, 0, 1, 170, 0
  .byte 1, 106, 128, 1, 106, 128, 0, 106, 128
  .byte 0, 90, 128, 0, 86, 128, 0, 102, 128
  .byte 1, 166, 128, 1, 166, 128, 1, 149, 64
  .byte 7, 223, 240, 7, 223, 240, 5, 85, 80, 0


   org $3a00 ; redefined chars are already in place!
char:
CH_SPACE = 32; null char: use the C= one to save some bytes
  ;.byte $00, $00, $00, $00, $00, $00, $00, $00

CH_V1 = 64  
  .byte $aa, $aa, $aa, $aa, $aa, $aa, $aa, $aa
CH_V2 = 65  
  .byte $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
CH_L1 = 66  
  .byte $66, $99, $66, $aa, $9a, $aa, $aa, $aa
  .byte $66, $99, $66, $99, $aa, $a6, $aa, $aa
CH_L2 = 68  
  .byte $55, $55, $55, $56, $95, $55, $59, $95
  .byte $55, $56, $55, $59, $95, $55, $65, $59  
CH_L3 = 70  
  .byte $55, $15, $55, $51, $55, $45, $55, $55
  .byte $55, $55, $51, $55, $55, $55, $55, $55
CH_L4 = 72
  .byte $00, $40, $11, $04, $11, $44, $11, $44
  .byte $00, $10, $01, $44, $11, $44, $11, $55
CH_L5 = 74
  .byte $00, $00, $00, $00, $04, $10, $01, $00
  .byte $00, $00, $00, $04, $00, $10, $00, $00

CH_LL = 76  
  .byte $ff, $ff, $ff, $ff, $ff, $ff, $ff, $55
CH_MM = 77  
  .byte $ff, $ff, $ff, $ff, $fd, $f4, $d1, $55  
  .byte $fd, $f6, $d9, $56, $16, $45, $56, $55
  .byte $bf, $af, $5b, $96, $65, $95, $66, $55
  .byte $ff, $ff, $ff, $ff, $bf, $6f, $5b, $55

CH_A = 81  
  .byte $24, $a5, $81, $81, $a5, $a5, $81, $81
CH_N = 82  
  .byte $81, $81, $a1, $a1, $85, $85, $81, $81
CH_G = 83  
  .byte $24, $80, $80, $80, $85, $81, $81, $24
CH_O = 84  
  .byte $24, $81, $81, $81, $81, $81, $81, $24
  
  